else if((s1 = strstr(nc_block_in, circle)) != NULL)	
{
/* check is the FROM command in operation ? */
   if(!from_move && mill_mode && !meas_tool) 
   { 
      uc1601("ERROR: CSL operation MUST include FROM point", 1);
      uc4540(chanel_out, 0);
	  strcat (strcpy(nc_block_out,"rm "),ptp_file);
	  system(nc_block_out);
	  break;
   }  
   sscanf(s1+7,"%lf,%lf,%lf,%lf,%lf,%lf,%lf,%lf,%lf",
          &tmp1,&tmp2,&tmp3,&tmp1,&tmp2,&tmp3,&R,&tolerance,&ratio);
   XYZ_input(s1+7,&Xc,&Yc,&Zc,&Nx,&Ny,&Nz,mill_mode);
   uc4514(chanel_in, str_goto); /* read a next GOTO command */
   XYZ_input(str_goto+5,&Xe,&Ye,&Ze,&tmp1,&tmp2,&tmp3,mill_mode);
   angle=acos( ((Xout-Xc)*(Xe-Xc)+(Yout-Yc)*(Ye-Yc)+(Zout-Zc)*(Ze-Zc))/(R*R));
   circle_unite(Xc,Yc,Zc,Nx,Ny,Nz,R, &Xe,&Ye,&Ze,&angle); 
   if(mill_mode && !tool_sys)
   {
      Br=coord_b1/180.0*M_PI;
      C_rotate(&Ye,&Ze,Cr); C_rotate(&Yc,&Zc,Cr);  C_rotate(&Ny,&Nz,Cr);
      Xe=around(Xe); Ye=around(Ye); Ze=around(Ze);
      Xc=around(Xc); Yc=around(Yc); Zc=around(Zc);
      circle_process_mill(coord_b1, Xout,Yout,Zout, Xc,Yc,Zc, Nx,Ny,Nz, Xe,Ye,Ze,
                          R,tolerance,ratio,angle );
	  Xold=Xe; Yold=Ye; Zold=Ze; Xout=Xe; Yout=Ye; Zout=Ze;	/* save what we need */
   }
   else if(mill_mode && tool_sys)
   {
      Br=coord_b1/180.0*M_PI;
	  Yc_cls=Yc; Zc_cls=Zc;
      C_rotate(&Ye,&Ze,Cr); C_rotate(&Yc,&Zc,Cr);  C_rotate(&Ny,&Nz,Cr);
      B_rotate(&Xe,&Ze,Xoff,Zoff,Br);
      B_rotate(&Xc,&Zc,Xoff,Zoff,Br);
      B_rotate(&Nx,&Nz,0.0,0.0,Br);
      Xe=around(Xe); Ye=around(Ye); Ze=around(Ze);
      Xc=around(Xc); Yc=around(Yc); Zc=around(Zc);
      if(fabs(Nz) - 1.0 > 0.00001)
      { 
         uc1601("ERROR: Normal of Circle doesnot match Tool axis", 1);
         uc4540(chanel_out, 0);
		 strcat (strcpy(nc_block_out,"rm "),ptp_file);
		 system(nc_block_out);
		 break;
	  }
      if(Nz > 0 && type_of_goto != 2) 
      { 
         strcpy(COMMAND," G2");	
         type_of_goto=2; 
      }
      else if(Nz < 0 && type_of_goto != 3) 
      { 
         strcpy(COMMAND," G3");	
         type_of_goto=3; 
      }
      else strcpy(COMMAND,"");
      sprintf(nc_block_out, "%s E%.3lf Y%.3lf I%.3lf J%.3lf",
                            COMMAND, Xe, Ye, Xc-Xout, Yc-Yout);
      PTP(add_cls(add_feedrate(nc_block_out),nc_block_in));
      Xold=Xe; Yold=Ye; Zold=Ze;		
      Xout=Xe; Yout=Ye; Zout=Ze;	/* save what we need */
   }
   else
   {
      if(Nz < 0.0 && type_of_goto != 3) 
      { 
         strcpy(COMMAND," G3"); 
         type_of_goto=3; 
      }
      else if(Nz >= 0.0 && type_of_goto != 2) 
      {	
         strcpy(COMMAND," G2"); 
         type_of_goto=2;	
      }
      else strcpy(COMMAND,""); 
      sprintf(nc_block_out, "%s X1=%.3lf Z1=%.3lf I%.3lf K%.3lf", 
                             COMMAND, Ye*2, Xe, Yc-Y, Xc-X);
      PTP(add_cls(add_feedrate(nc_block_out),nc_block_in));
      Xold=Xe; Yold=Ye; Zold=Ze;		
      X=Xe; Y=Ye; Z=Ze;	/* save what we need */
   }
} /* endof CIRCLE */
