/* Function read parameters of tool */

int f_tldata(char *str_1)
{
   char *mill = "MILL", *drill = "DRILL", *turn = "TURN", *lathe="LATHE"; 
   char *groove = "GROOVE", *thread = "THREAD", *button = "BUTTON";
   char *barrel = "BARREL", *tcutter = "TCUTTER", *borbar = "BORBAR";
   char *buttress = "BUTTRESS", *acme = "ACME", *ring = "RING";
   char *left = "LEFT", *rigth = "RIGTH", *s1;
   int type;
   if((s1 = strstr(str_1, drill)) == NULL && 
      (s1 = strstr(str_1, mill)) != NULL) 
   {
      sscanf(s1+5, "%lf,%lf,%lf,%lf,%lf,%lf,%lf,%lf,%lf,%lf", &mill_tool.diameter,
      &mill_tool.low_radius, &mill_tool.length, &mill_tool.taper_angle, 
      &mill_tool.tip_angle, &mill_tool.x_center_r1, &mill_tool.y_center_r1, 
      &mill_tool.upper_radius, &mill_tool.x_center_r2, &mill_tool.y_center_r2); 
      type = 1;
   }
   else if((s1 = strstr(str_1, barrel)) != NULL) 
   {
      sscanf(s1+7, "%lf,%lf,%lf,%lf,%lf,%lf,%lf,%lf", &barrel_tool.diameter,
      &barrel_tool.bar_radius, &barrel_tool.low_radius, &barrel_tool.upp_radius,
      &barrel_tool.length, &barrel_tool.flute_length, &barrel_tool.y_center_r1,
      &barrel_tool.shank_diameter);
      type = 2;
   }
   else if((s1 = strstr(str_1, tcutter)) != NULL) 
   {
      sscanf(s1+8, "%lf,%lf,%lf,%lf,%lf,%lf", &tcutter_tool.diameter,
      &tcutter_tool.low_radius, &tcutter_tool.upp_radius,
      &tcutter_tool.length, &tcutter_tool.flute_length, &tcutter_tool.shank_diameter);
      type = 3;
   }
   else if((s1 = strstr(str_1, mill)) != NULL && 
           (s1 = strstr(str_1, drill)) != NULL) 
   {
      s1 = strstr(str_1, drill);
      sscanf(s1+11, "%lf,%lf,%lf,%lf,%lf", &drill_tool.diameter,
      &drill_tool.corner_radius, &drill_tool.length, &drill_tool.point_angle, 
      &drill_tool.flute_length); 
      type = 4;
   }
   else if((s1 = strstr(str_1, drill)) != NULL && 
           (s1 = strstr(str_1, lathe)) != NULL) 
   {
      s1 = strstr(str_1, drill);
      sscanf(s1+11, "%lf,%lf,%lf,%lf,%lf", &drill_tool.diameter,
      &drill_tool.corner_radius, &drill_tool.length, &drill_tool.point_angle, 
      &drill_tool.flute_length); 
      type = 11;
   }
   else if((s1 = strstr(str_1, turn)) != NULL) 
   {
      if((s1 = strstr(str_1, button)) != NULL) 
      {
         sscanf(s1+7, "%6s%8s%lf,%lf,%lf,%lf", button_tool.tool_orient, 
         button_tool.type_of_work, &button_tool.noze_diam, &button_tool.holder_width,
         &button_tool.holder_heigth, &button_tool.orient_angle);
         type = 6;
      }
      else if((s1 = strstr(str_1, borbar)) != NULL) 
      {
         sscanf(s1+7, "%6s%8s%lf,%lf,%lf,%lf,%lf,%lf,%lf", bar_tool.tool_orient, 
         bar_tool.type_of_work, &bar_tool.noze_diam, &bar_tool.holder_width, 
         &bar_tool.lead_angle, &bar_tool.heel_angle, &bar_tool.bar_radius, 
         &bar_tool.holder_heigth, &bar_tool.orient_angle);
         type = 7;
      }
      else
      {
         s1 = strstr(str_1, turn);
         sscanf(s1+5, "%6s%8s%lf,%lf,%lf,%lf,%lf,%lf", turn_tool.tool_orient, 
         turn_tool.type_of_work, &turn_tool.noze_diam, &turn_tool.holder_width, 
         &turn_tool.lead_angle, &turn_tool.heel_angle, &turn_tool.holder_heigth, 
         &turn_tool.orient_angle);
         type = 5;
      }	 
   }	 
   else if((s1 = strstr(str_1, groove)) != NULL) 
   {
      if((s1 = strstr(str_1, ring)) != NULL)
      {
         sscanf(s1+5, "%5s%8s%4s%lf,%lf,%lf,%lf,%lf,%lf,%lf,%lf", 
         angle_groove_tool.tool_orient, angle_groove_tool.type_of_work, 
         angle_groove_tool.trace_size, &angle_groove_tool.insert_width,
         &angle_groove_tool.left_angle, &angle_groove_tool.rigth_angle, 
         &angle_groove_tool.max_depth, &angle_groove_tool.lead_angle, 
         &angle_groove_tool.insert_angle, &angle_groove_tool.holder_height,
         &angle_groove_tool.holder_width);
          type = 9;
      }
      else
      {
         s1 = strstr(str_1, groove);
         sscanf(s1+7, "%5s%8s%4s%lf,%lf,%lf,%lf,%lf,%lf,%lf,%lf", groove_tool.tool_orient, 
         groove_tool.type_of_work, groove_tool.trace_size, &groove_tool.insert_width,
         &groove_tool.left_radius, &groove_tool.rigth_radius, &groove_tool.max_depth,
         &groove_tool.lead_angle, &groove_tool.insert_angle, &groove_tool.holder_height,
         &groove_tool.holder_width);
      }
      type = 8;
   }
   else if((s1 = strstr(str_1, thread)) != NULL) 
   {
      if((s1 = strstr(str_1, acme)) != NULL) 
      {
         sscanf(s1+5, "%5s%8s%lf,%lf,%lf,%lf,%lf,%lf,%lf,%lf", acme_thread_tool.tool_orient, 
         acme_thread_tool.type_of_work, &acme_thread_tool.max_depth, 
         &acme_thread_tool.holder_width, &acme_thread_tool.refief_angle, 
         &acme_thread_tool.heel_angle, &acme_thread_tool.nose_width,
         &acme_thread_tool.holder_height, &acme_thread_tool.insert_width, 
         &acme_thread_tool.tip_offset);
      }
      else if((s1 = strstr(str_1, buttress)) != NULL)
      {
         sscanf(s1+9, "%5s%8s%lf,%lf,%lf,%lf,%lf,%lf,%lf,%lf", but_thread_tool.tool_orient, 
         but_thread_tool.type_of_work, &but_thread_tool.max_depth, 
         &but_thread_tool.holder_width, &but_thread_tool.refief_angle, 
         &but_thread_tool.heel_angle, &but_thread_tool.nose_radius, 
         &but_thread_tool.holder_height, &but_thread_tool.insert_width, 
         &but_thread_tool.tip_offset);
      }
      else
      {
	 s1 = strstr(str_1, thread);
         sscanf(s1+7, "%5s%8s%lf,%lf,%lf,%lf,%lf,%lf,%lf", thread_tool.tool_orient, 
         thread_tool.type_of_work, &thread_tool.max_depth, &thread_tool.holder_width,
         &thread_tool.refief_angle, &thread_tool.heel_angle, &thread_tool.holder_height,
         &thread_tool.insert_width, &thread_tool.tip_offset);
      }
      type = 10;
   }      				 
   else uc1601("Unknow (new) tool type", 1);
   return type;
}
