                           /* ALL FUNNCTIOn WHICH HAVE A NAME f_... */
/* Coolant on/off commands */
void f_coolnt(char *str_1)
{
	char *on = "ON", *off = "OFF", *mist = "MIST", *flood = "FLOOD", *s1;	
	if((s1 = strstr(str_1, on)) != NULL)	        PTP(" M3=8");
	else if((s1 = strstr(str_1, off)) != NULL)		 PTP("	M3=9");
	else if((s1 = strstr(str_1, mist)) != NULL)	 PTP(" M3=7");
	else if((s1 = strstr(str_1, flood)) != NULL)	PTP(" M99" );
}

/* Delay command */

void f_delay(char *str_1)
{
	double d_delay, d_tmp;
	int prec = 0;
	sscanf(str_1+6, "%lf", &d_delay);
	if(modf(d_delay, &d_tmp) == 0.0) prec = 0;
	else prec = 3;
	sprintf(nc_block_out, " G4 X%.*lf", prec, d_delay);
}

/* LOAD TOOL command */

int f_load_tool(double *coord_b1, int multi_axis, char *str_1)
{
   int tool_num;
   (*coord_b1)=around(*coord_b1);
   sscanf(str_1+10, "%d", &tool_num);
   if(multi_axis == 1)
   {
      sprintf(nc_block_out, " T1=%d R1=1 R3=0 R4=0 R6=0 L106", tool_num);
      PTP(nc_block_out);
      PTP(" @36a R52 K2        ( Read actual D-No )");
      PTP(" @303 R53 K1 K4000  ( Read swivek-dimension )");
      PTP(" @320 R54 K1 R52 K2 ( Read tool L1 - geometry )");
      PTP(" @320 R55 K1 R52 K5 ( Read tool L1 wcar )");
      PTP(" R51=R53+R54+R55    ( Total Lenght of tool )");
      PTP(" M6=150");
      PTP(" M3=161 H3=1");
      PTP(" D0");
   }
   else
   {
      sprintf(nc_block_out, " T1=%d R1=1 R3=0 R4=%.3lf R6=0 L106", tool_num, *coord_b1);
      PTP(nc_block_out);
      if(fabs(fmod(*coord_b1,2.5)) > 0.01) PTP(" M6=152"); 
      else PTP(" M6=151");
  /* Process monitoring -> Not using for measuring and thread tools !!! */			
		/*			
						sprintf(nc_block_out, " M3=161 H3=%d", tool_change);
						PTP(nc_block_out);	
						if(tool_change > 200) tool_change = 1;
      tool_change++;
  */
   }
   if (tool_num > 99999990) return (1);
   else                     return (0);
}

/* CUTCOM command */

int f_cutcom(char *str_1)
{
   char *on = "ON", *off = "OFF", *left = "LEFT", *right = "RIGHT", *s1;
   int comp;
   if     ((s1 = strstr(str_1, on)) != NULL)    comp = 42;
   else if((s1 = strstr(str_1, off)) != NULL)   comp = 40;
   else if((s1 = strstr(str_1, left)) != NULL)  comp = 41;
   else if((s1 = strstr(str_1, right)) != NULL) comp = 42;
   return comp;
}

/* SPINDEL ON/OFF command */

void f_spindl( int chanel_in, int mill_mode, char *str_1)
{
   char *s1, str_2[256], *rpm = "RPM", *smm = "SMM", *maxrpm = "MAXRPM"; 
   char *clw = "CLW", *cclw = "CCLW", *range = "RANGE", *off = "OFF";
   int i_range, i_rpm, i_smm, m1, mode = 95, file_pos;
   int max_rpm, in;
   if((s1 = strstr(str_1, clw)) != NULL) m1 = 3;
   if((s1 = strstr(str_1, cclw)) != NULL) m1 = 4;
   if((s1 = strstr(str_1, maxrpm)) != NULL)
   {
      sscanf(s1+7, "%d", &max_rpm);
      sprintf(nc_block_out, " G92 S1=%d", max_rpm);	PTP(nc_block_out);
   }
   if((s1 = strstr(str_1, range)) != NULL)
   {
      sscanf(s1+6, "%d", &i_range);
      sprintf(nc_block_out, " M1=4%d", i_range);	PTP(nc_block_out);
   }
   if((s1 = strstr(str_1, smm)) != NULL)
   {
      sscanf(s1+4, "%d", &i_smm);
						PTP(" M1=61");
      sprintf(nc_block_out, " G96 S1=%d M1=%d", i_smm, m1);	PTP(nc_block_out);
   }
   else if((s1 = strstr(str_1, rpm)) != NULL)
   {
      sscanf(s1+4, "%d", &i_rpm);
      file_pos = uc4534(chanel_in);
      while((in = uc4514(chanel_in, str_2) >= 0))
      {
         if((s1 = strstr(str_2, "MMPM")) != NULL) 
         {
            mode = 94;
	        break;
	     }
	     else if((s1 = strstr(str_2, "MMPR")) != NULL)
	     {   
	        mode = 95;
            break;
	     }
      }
      uc4535(chanel_in, file_pos);
      if(mill_mode == 0)
      {
         PTP(" M1=61");
         sprintf(nc_block_out, " G%d S1=%d M1=%d", mode, i_rpm, m1);	PTP(nc_block_out);
      }
      else
      {
         PTP(" M3=61");
         sprintf(nc_block_out, " G%d S3=%d M3=%d", mode, i_rpm, m1); PTP(nc_block_out);
      }
   }
   else if((s1 = strstr(str_1, off)) != NULL)
   {
      if(mill_mode == 0)	PTP(" M1=5");
      else															PTP("	M3=5");
   }
}

/* GOHOME command */

void f_gohome( int mill_mode, char *str_1)
{  
   double x, y, z;
   XYZ_input(str_1+7, &x, &y, &z, &tmp1,&tmp2,&tmp3,mill_mode);
   x=around(x); y=around(y); z=around(z); 
   if(mill_mode == 1)	sprintf(nc_block_out, " G53 G0 D0 E1=%.3lf Y1=%.3lf Z1=%.3lf", z, y, x	);
   else					sprintf(nc_block_out, " G53 G0 D0 X1=%.3lf Z1=%.3lf"         , y*2,  x );
   PTP(nc_block_out);
}
