/* Measuring cycle definition */
void f_l822() 
{
  double position[3] = {0.0, 0.0, 0.0}, position1[3] = {0.0, 0.0, 0.0};
  char *message = "Select point to prepare position";
  char menu_list[6][38] = {"X1 axis", "E1 axis", "Z1 axis", "Y1 axis", 
  "C1 axis", "B1 axis"};
  char menu_list_1[3][16]={"R2","R3","R4"};
  int mes_axis, type_items[3]={200, 100, 100};
  int points[3]={1,1,1}, mode[2] = {6, 0}, irc, type_item_d[1]={200};
  double input_d[3] = {10.0, 0.0, 0.0}, degree_tool=0.0;
  char inp_values[3][31] = {1,1,1};
  char menu_list_21[1][16]={"Angle of B axis"};
  char *mes_tool = "Input angle (-105...90) of orientation measuring tool";
  
  message = "Select axis for measuring"; 
  irc = uc1603(message, 1, menu_list, 6);	if(irc==i_cancel) PTP_CLOSE(" PTP close by CANSEL comand");
  switch(irc)
  {
     case 2:  exit(0);				break;
     case 5:  mes_axis = 1;			break;
     case 6:  mes_axis = 4;			break;
     case 7:  mes_axis = 2;			break;
     case 8:  mes_axis = 5;			break;
     case 9:  mes_axis = 3;			break;
     case 10: mes_axis = 6;		    break;
     default: mes_axis = 4;
  }
  message = "Input parameters measuring cycle L822";
  irc = uc1613(message, menu_list_1, 3, points, input_d, 
  inp_values, type_items);
  if(irc == 2) exit(0);
  around(input_d[0]);
  sprintf(nc_block_out, " R1=%d R2=%.3lf R3=%d R4=%d L822",mes_axis, input_d[0], points[1], points[2]); 
  PTP(nc_block_out);
  return	;
}

/* Create cycle for Search a characteristic */

void f_l823()
{
   double position[3] = {0.0, 0.0, 0.0}, position1[3] = {0.0, 0.0, 0.0};
   char *message = "Select point to prepare position";
   char menu_list_21[1][16]={"Angle of B axis"};
   char menu_list[6][38] = {"X1 axis", "E1 axis", "Z1 axis", "Y1 axis", 
   "C1 axis", "B1 axis"};
   char menu_list_1[4][16]={"R2","R4","R5","R6"};
   int mes_axis, search_axis, type_items[4]={200, 200, 100, 100};
   int points[4]={1,1,1,1}, mode[2] = {6, 0}, irc, type_item_d[1]={200};
   double input_d[4] = {10.0, 10.0, 0.0, 0.0}, degree_tool=0.0;
   char inp_values[4][31] = {1,1,1,1};
   char *mes_tool = "Input angle (-105...90) of orientation measuring tool";
  
   message = "Select axis for measuring"; 
   irc = uc1603(message, 1, menu_list, 6);	if(irc==i_cancel) PTP_CLOSE(" PTP close by CANSEL comand");
   switch(irc)
   {
      case 5 : mes_axis = 1;	break;
      case 6 : mes_axis = 4;	break;
      case 7 : mes_axis = 2;	break;
      case 8 : mes_axis = 5;	break;
      case 9 : mes_axis = 3;	break;
      case 10: mes_axis = 6;    break;
      default: mes_axis = 4;
    }
    message = "Select searching axis";
    irc = uc1603(message, 1, menu_list, 6);	if(irc==i_cancel) PTP_CLOSE(" PTP close by CANSEL comand");
    switch(irc)
    {
      case  5: search_axis = 1;	break;
      case  6: search_axis = 4;	break;
      case  7: search_axis = 2;	break;
      case  8: search_axis = 5;	break;
      case  9: search_axis = 3;	break;
      case 10: search_axis = 6;	break;
      default: search_axis = 4;
   }
   message = "Input parameters measuring cycle L823";
   irc = uc1613(message, menu_list_1, 4, points, input_d, 
   inp_values, type_items);
   sprintf(nc_block_out, " R1=%d R2=%.3lf R3=%d R4=%.3lf R5=%d R6=%d L823",
   mes_axis, input_d[0], search_axis, input_d[1], points[2], points[3]);
   PTP(nc_block_out);
}

/* Create cycle for testing a characteristic */

void f_l824()
{
    double position[3] = {0.0, 0.0, 0.0}, position1[3] = {0.0, 0.0, 0.0};
    char *message = "Select point to prepare position";
    char menu_list[6][38] = {"X1 axis", "E1 axis", "Z1 axis", "Y1 axis", 
    "C1 axis", "B1 axis"};
    char menu_list_1[2][16]={"R2","R3"};
    int mes_axis, type_items[2]={200, 100}, type_item_d[1]={200};
    int points[2]={1,1}, mode[2] = {6, 0}, irc;
    double input_d[2] = {10.0, 0.0}, degree_tool=0.0;
    char inp_values[2][31] = {1,1};
    char menu_list_21[1][16]={"Angle of B axis"};	
    char *mes_tool = "Input angle (-105...90) of orientation measuring tool";
    message = "Select axis for measuring"; 
    irc = uc1603(message, 1, menu_list, 6);	if(irc==i_cancel) PTP_CLOSE(" PTP close by CANSEL comand");
    switch(irc)
    {
       case  5: mes_axis = 1;	break;
       case  6: mes_axis = 4;	break;
       case  7: mes_axis = 2;	break;
       case  8: mes_axis = 5;	break;
       case  9: mes_axis = 3;	break;
       case 10: mes_axis = 6;	break;
       default: mes_axis = 4;
   }
   message = "Input parameters measuring cycle L823";
   irc = uc1613(message, menu_list_1, 2, points, input_d, inp_values, type_items);
   input_d[0]=around(input_d[0]);
   sprintf(nc_block_out, " R1=%d R2=%.3lf R3=%d L824", mes_axis, input_d[0], points[1]);
   PTP(nc_block_out);
   return ;
}

/* Create cycle for measuring diameter to 2 points */

void f_l825()
{
   double position[3] = {0.0, 0.0, 0.0}, position1[3] = {0.0, 0.0, 0.0};
   double position2[3] = {0.0, 0.0, 0.0}, degree_tool=0.0;
   int irc, mode[2] = {6, 0}, mes_axis, search_axis;
   int type_item_d[1]={200};
   char inp_values[1][31]={1};
   char menu_list_2[1][16]={"Angle of B axis"};
   char *message = "Select point to prepare position";
   char *mes_sel_axis = "Select measuring axis";
   char menu_list[6][38] = {"X1 axis", "E1 axis", "Z1 axis", "Y1 axis", 
   "C1 axis", "B1 axis"};
   char menu_list_825[13][16]={"R2", "R3", "R4", "R6", "R7", "R11", 
   "R21", "R22", "R23", "R25", "R26", "R27", "R28"};
   int type_item_825[13] = {200,200,100,200,200,200,100,100,100,200,200,200,200};
   int input_int_825[13] = {1,1,1,1,1,1,1,1,1,1,1,1,1};
   char input_char_825[13][31] = {"1","2","3","4","5","6",
   "8","9","10","11","12","13","14"}; 
   double input_double_825[13] = {252.6,0.0,0.0,30.0,2.0,0.0,
   0.0,0.0,0.0,0.016,-0.016,1.0,0.2};
   char *mes_tool = "Input angle (-105...90) of orientation measuring tool";
   int i;

   irc = uc1603(mes_sel_axis, 1, menu_list, 6);	if(irc==i_cancel) PTP_CLOSE(" PTP close by CANSEL comand");
   switch(irc)
   {
      case  5: mes_axis = 1;	break;
      case  6: mes_axis = 4;	break;
      case  7: mes_axis = 2;	break;
      case  8: mes_axis = 5;	break;
      case  9: mes_axis = 3;	break;
      case 10: mes_axis = 6;	break;
      default: mes_axis = 4;
   }
   mes_sel_axis = "Select compensation axis";
   irc = uc1603(mes_sel_axis, 1, menu_list, 6);	if(irc==i_cancel) PTP_CLOSE(" PTP close by CANSEL comand");
   switch(irc)
   {
      case  5: search_axis = 1;	break;
      case  6: search_axis = 4; break;
      case  7: search_axis = 2;	break;
      case  8: search_axis = 5; break;
      case  9: search_axis = 3; break;
      case 10: search_axis = 6;	break;
     default : search_axis = 4;	
              
   }
   mes_sel_axis = "Input parameters of measuring cycle L825";
   irc = uc1613(mes_sel_axis, menu_list_825, 13, input_int_825, input_double_825, 
   input_char_825, type_item_825);
   for (i=0;i<13;i++) input_double_825[i]=around(input_double_825[i]);
   sprintf(nc_block_out, " R1=%d R2=%.3lf R3=%.3lf R4=%d R5=%d R6=%.3lf R7=%.3lf R11=%.3lf\
    \nR21=%d R22=%d R23=%d R25=%.3lf R26=%.3lf R27=%.3lf R28=%.3lf L825",
   mes_axis, input_double_825[0], input_double_825[1], input_int_825[2], search_axis, input_double_825[3], input_double_825[4], 
   input_double_825[5], input_int_825[6], input_int_825[7], input_int_825[8], 
   input_double_825[9], input_double_825[10], input_double_825[11], input_double_825[12]);
   PTP(nc_block_out);

   return ;
}

/* Create cycle for measuring angle */

void f_l827()
{
   double position[3] = {0.0, 0.0, 0.0}, position1[3] = {0.0, 0.0, 0.0};
   char *message = "Select point to prepare position";
   char menu_list[6][38] = {"X1 axis", "E1 axis", "Z1 axis", "Y1 axis", 
   "C1 axis", "B1 axis"};
   char menu_list_1[3][16]={"R2","R3","R5"};
   int mes_axis, search_axis, type_items[3]={200, 100, 200};
   int points[3]={1,1,1}, mode[2] = {6, 0}, irc, type_item_d[1]={200};
   double input_d[3] = {10.0, 0.0, 10.0}, degree_tool=0.0;
   char inp_values[3][31] = {1,1,1};
   char menu_list_21[1][16]={"Angle of B axis"};
   char *mes_tool = "Input angle (-105...90) of orientation measuring tool";

   message = "Select axis for measuring"; 
   irc = uc1603(message, 1, menu_list, 6);	if(irc==i_cancel) PTP_CLOSE(" PTP close by CANSEL comand");
   switch(irc)
   {
      case  5: mes_axis = 1;	break;
      case  6: mes_axis = 4;    break;
      case  7: mes_axis = 2;	break;
      case  8: mes_axis = 5;	break;
      case  9: mes_axis = 3;	break;
      case 10: mes_axis = 6;	break;
      default: mes_axis = 4;
   }
   message = "Select searching axis";
   irc = uc1603(message, 1, menu_list, 6);	if(irc==i_cancel) PTP_CLOSE(" PTP close by CANSEL comand");
   switch(irc)
   {
     case  5: search_axis = 1;	break;
     case  6: search_axis = 4;	break;
     case  7: search_axis = 2;	break;
     case  8: search_axis = 5;	break;
     case  9: search_axis = 3;	break;
     case 10: search_axis = 6;	break;
     default: search_axis = 4;	break;
   }
   message = "Input parameters measuring cycle L827";
   irc = uc1613(message, menu_list_1, 3, points, input_d, inp_values, type_items);    
   input_d[0]=around(input_d[0]);
   input_d[2]=around(input_d[2]);
   sprintf(nc_block_out, "R1=%d R2=%.3lf R3=%d R4=%d R5=%.3lf L827", mes_axis, input_d[0], points[1], search_axis, input_d[2]);
   PTP(nc_block_out); 
   return ;
}

/* Create cycle L828 for measure true running */

void f_l828()
{
   double position[3] = {0.0, 0.0, 0.0}, position1[3] = {0.0, 0.0, 0.0};
   char *message = "Select point to prepare position";
   char menu_list[6][38] = {"X1 axis", "E1 axis", "Z1 axis", "Y1 axis", 
   "C1 axis", "B1 axis"};
   char menu_list_1[4][16]={"R2","R3","R5","R6"};
   int mes_axis, type_items[4]={200, 100, 200, 100};
   int points[4]={1,1,1,1}, mode[2] = {6, 0}, irc, type_item_d[1]={200};
   double input_d[4] = {10.0, 0.0, 0.0, 0.0}, degree_tool=0.0;
   char inp_values[4][31] = {1,1,1,1};   
   char menu_list_21[1][16]={"Angle of B axis"};
   char *mes_tool = "Input angle (-105...90) of orientation measuring tool";
   
   message = "Select axis for measuring"; 
   irc = uc1603(message, 1, menu_list, 6);	if(irc==i_cancel) PTP_CLOSE(" PTP close by CANSEL comand");
   switch(irc)
   {
      case  5: mes_axis = 1;	break;
      case  6: mes_axis = 4;	break;
      case  7: mes_axis = 2;	break;
      case  8: mes_axis = 5;	break;
      case  9: mes_axis = 3;	break;
      case 10: mes_axis = 6;	break;
      default: mes_axis = 4;
   }
   message = "Input parameters measuring cycle L828";
   irc = uc1613(message, menu_list_1, 4, points, input_d, 
   inp_values, type_items);    
   input_d[0]=around(input_d[0]);
   input_d[2]=around(input_d[2]);
   sprintf(nc_block_out, " R1=%d R2=%.3lf R3=%d R4=3 R5=%.3lf R6 L828", mes_axis, input_d[0], points[1], input_d[2]);
   PTP(nc_block_out); 
   return ;
}

/* Create cycle for calculate values */

void f_l830()
{
   char menu_list_830[3][16]={"R1", "R2", "R3"};
   char input_char_830[3][31]={"1","2","3"};
   int input_int_830[3]={1, 2, 1};
   int type_item_830[3]={100,100,100};
   double input_double_830[3]={0.0, 0.0, 0.0};
   int irc;
   char *message = "Input parameters of measuring cycle L830";
   irc = uc1613(message, menu_list_830, 3, input_int_830, input_double_830, 
   input_char_830, type_item_830);
   sprintf(nc_block_out, " R1=%d R2=%d R3=%d L830", input_int_830[0], input_int_830[1], input_int_830[2]);
   PTP(nc_block_out);
   return ;
}

/* Create cycle for write parameters in memory */

void f_l831()
{
   char menu_list_831[9][16]={"R1","R2","R3","R4","R5","R6","R7","R8","R11"};
   char input_char_831[9][31]={"1", "2", "3", "4", "5", "6", "7", "8", "9"};
   int input_int_831[9]={1, 1, 1, 4, 5, 6, 7, 8, 9};
   int type_item_831[9]={100,100,100,200,200,200,200,200,200};
   double input_double_831[9]={0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0};
   int irc, i;
   char *mes_sel_axis = "Input parameters of measuring cycle L831";
   irc = uc1613(mes_sel_axis, menu_list_831, 9, input_int_831, input_double_831,
   input_char_831, type_item_831); 

   for(i = 3; i < 9; i++) input_double_831[i] = around(input_double_831[i]);

   sprintf(nc_block_out, " R1=%d R2=%d R3=%d R4=%.3lf R5=%.3lf R6=%.3lf R7=%.3lf R8=%.3lf R11=%.3lf L831",
   input_int_831[0], input_int_831[1], input_int_831[2],	input_double_831[3], input_double_831[4],  
   input_double_831[5], input_double_831[6], input_double_831[7], input_double_831[8]);
   PTP(nc_block_out);
   return ;
}

/* Create cycle for Entry in zero shift */

void f_l832()
{
   double degree_tool=0.0;
   int type_item_d[1]={200};
   char menu_list_21[1][16]={"Angle of B axis"};
   int zero_shift, mes_axis, type_of_entry, irc;
   char inp_values[1][31]={1};
   char *message = "Select zero shift";
   char *mes_sel_axis; 
   char menu_list[6][38] = {"X1 axis", "E1 axis", "Z1 axis", "Y1 axis", 
   "C1 axis", "B1 axis"};
   char menu_list_10[4][38]={"G54", "G55", "G56", "G57"};
   char menu_list_11[4][38]={"Write rough shift", "Write fine shift", 
   "Add to rough shift", "Add to fine shift"};
   char *mes_tool = "Input angle (-105...90) of orientation measuring tool";

   irc = uc1603(message, 1, menu_list_10, 4);	
   if(irc == i_cancel) PTP_CLOSE(" PTP close by CANSEL comand");
   switch(irc)
   {
      case  5: zero_shift = 54;	break;
      case  6: zero_shift = 55; break;
      case  7: zero_shift = 56; break;
      case  8: zero_shift = 57;	break;
      default: zero_shift = 54;	
   }
   mes_sel_axis = "Select measuring axis"; 
   irc = uc1603(mes_sel_axis, 1, menu_list, 6);	
   if(irc == i_cancel) PTP_CLOSE(" PTP close by CANSEL comand");
   switch(irc)
   {
      case  5: mes_axis = 1;	break;
      case  6: mes_axis = 4;	break;
      case  7: mes_axis = 2;	break;
      case  8: mes_axis = 5;	break;
      case  9: mes_axis = 3;	break;
      case 10: mes_axis = 6;	break;
      default: mes_axis = 4;
   }
   mes_sel_axis = "Select type of entry"; 
   irc = uc1603(mes_sel_axis, 1, menu_list_11, 4);	if(irc==i_cancel) PTP_CLOSE(" PTP close by CANSEL comand");
   switch(irc)
   {
   case  5: type_of_entry = 1;	break;
   case  6: type_of_entry = 2;	break;
   case  7: type_of_entry = 3;  break;
   case  8: type_of_entry = 4;	break;
   default: type_of_entry = 1;	
   } 
   sprintf(nc_block_out, " R1=%d R2=%d R3=%d L832", zero_shift, mes_axis, type_of_entry);
   PTP(nc_block_out);
   return ;
}

/* Create cycle for write measuring data in hard disk */

void f_l833()
{
   char *message = "Input parameters for measuring cycle L834";
   int irc, points[3] = {1,1,1}, type_item[3] = {100, 100, 100};
   double input_d[3] = {0.0, 0.0, 0.0};
   char menu_list[3][16] = {"R1", "R2", "R3"};
   char inp_values[3][31] = {"1", "1", "1"};
   irc = uc1613(message, menu_list, 3, points, input_d, 
   inp_values, type_item);
   sprintf(nc_block_out, " R1=%d R2=%d R3=%d L833", points[0], points[1], points[2]);
   PTP(nc_block_out);
   return ;
}

/* Create cycle for printing measuring data in printer */

void f_l834()
{
   char *message = "Input parameters for measuring cycle L834";
   int irc, points[3] = {1,1,1}, type_item[3] = {100, 100, 100};
   double input_d[3] = {0.0, 0.0, 0.0};
   char menu_list[3][16] = {"R1", "R2", "R3"};
   char inp_values[3][31] = {"1","1","1"};
   irc = uc1613(message, menu_list, 3, points, input_d, inp_values, type_item);
   sprintf(nc_block_out, " R1=%d R2=%d R3=%d L834", points[0], points[1], points[2]);
   PTP(nc_block_out);
   return ;
}

/* Create cycle position of tailstock */

void f_l930( int zero_shift)
{
   char *message = "Select position of tailstock"; 
   double position[3], position1[3];
   int irc, mode[2] = {6,0};
   irc = uc1616(message, mode, 0, position);
   UF_CSYS_map_point(UF_CSYS_ROOT_COORDS, position, UF_CSYS_ROOT_WCS_COORDS, position1);
   position1[0] = around(position1[0]);

   if(position1[0] == 9999.000) sprintf(nc_block_out, " R1=9999 R2=110 R3=%d L930",  zero_shift);
   else																									sprintf(nc_block_out, " R1=%.3lf R2=110 R3=%d L930", position1[0]+145.0, zero_shift);
   PTP(nc_block_out);
   return ;
}

/* Create cycle position of lunet */

void f_l931( int zero_shift)
{
   char *message = "Select position of lunet"; 
   double position[3], position1[3];
   int irc, mode[2] = {6,0};
   irc = uc1616(message, mode, 0, position);
   UF_CSYS_map_point(UF_CSYS_ROOT_COORDS, position, UF_CSYS_ROOT_WCS_COORDS, position1);
   
   position1[0] = around(position1[0]);
   if(position1[0] == 9999.000) sprintf(nc_block_out, " R1=9999 R2=0 R3=%d L931" , zero_shift);
   else																									sprintf(nc_block_out, " R1=%.3lf R2=0 R3=%d L931",	position1[0], zero_shift);
   PTP(nc_block_out);
   return ;
}

/* Create command to close lunet */

void f_m56()
{
   PTP(" M56");	PTP(" G4 X2");
   return ;
}

/* Create command to open lunet */

void f_m57()
{
   PTP(" M57");	PTP(" G4 X2");
   return ;
}

/* Create command to close tailstock */

void f_m13()
{
   PTP(" M13");	PTP(" G4 X2");
   return ;
}

/* Create command to open tailstock */

void f_m14()
{
   PTP(" M14"); PTP(" G4 X2");
   return ;
}

/* Create command to orientation main (turning) spindel */

void f_m19( int mill_mode)
{
   if(mill_mode == 0)	PTP(add_cls(" S1=0 M1=19",nc_block_in));
   else					PTP(add_cls(" S3=0 M3=19",nc_block_in));
   return ;
}

/* Create command for call subprogram to selected tool change 
   position and write subprogram in file SPF9999 */

void f_l9999()
{
   double position[3], position1[3];
   int ch_out_sp, irc,	mode[2] = {6,0};
   char *message = "Select point for tool change position";
   char	*error;
   char sp_file[9] = "SPF9999";
   char out_str[128];
   ch_out_sp = uc4504(sp_file, 3, 2004);
   
   if(chanel_out < 0)
   {
      UF_get_fail_message(ch_out_sp, error);
      uc1601(error, 1);
   }			
   irc = uc1616(message, mode, 0, position);
   UF_CSYS_map_point(UF_CSYS_ROOT_COORDS, position, UF_CSYS_ROOT_WCS_COORDS, position1);
   position1[0] = around(position1[0]);
			position1[2] = around(position1[2]);
   sprintf(out_str, "N1 G58 G0 D0 E1=%.3lf Y1=0 Z1=%.3lf", position1[2], position1[0]);   
   uc4524(ch_out_sp,nc_block_out);	
   uc4540(ch_out_sp, 0);
   return ;
}


void position_out(double *position) /* this function output 3 coordinat in PTP file */

{
   position[0]=around(position[0]);
   position[1]=around(position[1]);
   position[2]=around(position[2]);
   
   sprintf(nc_block_out, " G0 E1=%.3lf Y1=%.3lf Z1=%.3lf", 
           position[2], position[1], position[0]);
   PTP(nc_block_out);
}
